commit d41f8d519200905926c36a64e153b8f25a714193
Author: freddy77 <freddy77>
Date:   Tue Jun 29 12:07:54 2010 +0000

    do not use strtok which is not reentrant

diff --git a/ChangeLog b/ChangeLog
index 1c0f42b..d1bd0b0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Jun 29 14:07:32 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/mem.c: do not use strtok which is not reentrant
+
 Tue Jun 29 14:00:51 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/mem.c: use ISO-8859-1 if ASCII is detected
 
@@ -2537,4 +2540,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3045 2010/06/29 12:01:17 freddy77 Exp $
+$Id: ChangeLog,v 1.3046 2010/06/29 12:07:54 freddy77 Exp $
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 56bfede..d5d8b01 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.200 2010/06/29 12:01:17 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.201 2010/06/29 12:07:54 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -809,7 +809,7 @@ tds_alloc_connection(TDSLOCALE * locale)
 #if HAVE_NL_LANGINFO && defined(CODESET)
 	char *charset;
 #else
-	char *lc_all;
+	char *lc_all, *tok = NULL;
 #endif
 
 	TEST_MALLOC(connection, TDSCONNECTION);
@@ -848,8 +848,8 @@ tds_alloc_connection(TDSLOCALE * locale)
 	if ((lc_all = strdup(setlocale(LC_ALL, NULL))) == NULL)
 		goto Cleanup;
 
-	if (strtok(lc_all, ".")) {
-		char *encoding = strtok(NULL, "@");
+	if (strtok_r(lc_all, ".", &tok)) {
+		char *encoding = strtok_r(NULL, "@", &tok);
 		if (encoding) {
 			if (!tds_dstr_copy(&connection->client_charset, encoding))
 				goto Cleanup;

